#
# spec file for package guile1
#
# Copyright (c) 2013 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


%define binpref guile1
Name:           guile1
BuildRequires:  automake
BuildRequires:  gc-devel
BuildRequires:  gmp-devel
BuildRequires:  libtool
%if 0%{?suse_version}
BuildRequires:  pkg-config
%else
BuildRequires:  pkgconfig
%endif
BuildRequires:  readline-devel
Version:        1.8.8
Release:        0
Summary:        GNU's Ubiquitous Intelligent Language for Extension
License:        LGPL-2.1+
Group:          Development/Languages/Scheme
Url:            http://www.gnu.org/software/guile/
Source0:        guile-%{version}.tar.bz2
Patch1:         guile-64bit.patch
Patch2:         guile-1.6.10-mktemp.patch
Patch3:         guile-popen-test.patch
Patch5:         guile-gcc.patch
Patch6:         guile-automake-1.13.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
PreReq:         fileutils sh-utils
PreReq:         %install_info_prereq
Conflicts:      slib < 3a5
# Require the library packages, at least current version. The *.so symlinks are in the main package (due to dlopen(), so without the requires, it would be dangling symlinks.
Requires:       libguile-srfi-srfi-1-v-3-3 >= %{version}
Requires:       libguile-srfi-srfi-13-14-v-3-3 >= %{version}
Requires:       libguile-srfi-srfi-4-v-3-3 >= %{version}
Requires:       libguile-srfi-srfi-60-v-2-2 >= %{version}
Requires:       libguile17 >= %{version}
Requires:       libguilereadline-v-17-17 >= %{version}

%description
This is Guile, a portable, embeddable Scheme implementation written in
C. Guile provides a machine independent execution platform that can be
linked in as a library when building extensible programs.

%package -n libguile17
Summary:        GNU's Ubiquitous Intelligent Language for Extension
Group:          Development/Languages/Scheme

%description -n libguile17
This is Guile, a portable, embeddable Scheme implementation written in
C. Guile provides a machine independent execution platform that can be
linked in as a library when building extensible programs. This package
contains the shared libraries.

%package -n libguile-srfi-srfi-1-v-3-3
Summary:        GNU's Ubiquitous Intelligent Language for Extension
Group:          Development/Languages/Scheme

%description -n libguile-srfi-srfi-1-v-3-3
This is Guile, a portable, embeddable Scheme implementation written in
C. Guile provides a machine independent execution platform that can be
linked in as a library when building extensible programs. This package
contains the shared libraries.

%package -n libguile-srfi-srfi-4-v-3-3
Summary:        GNU's Ubiquitous Intelligent Language for Extension
Group:          Development/Languages/Scheme

%description -n libguile-srfi-srfi-4-v-3-3
This is Guile, a portable, embeddable Scheme implementation written in
C. Guile provides a machine independent execution platform that can be
linked in as a library when building extensible programs. This package
contains the shared libraries.

%package -n libguile-srfi-srfi-13-14-v-3-3
Summary:        GNU's Ubiquitous Intelligent Language for Extension
Group:          Development/Languages/Scheme

%description -n libguile-srfi-srfi-13-14-v-3-3
This is Guile, a portable, embeddable Scheme implementation written in
C. Guile provides a machine independent execution platform that can be
linked in as a library when building extensible programs. This package
contains the shared libraries.

%package -n libguile-srfi-srfi-60-v-2-2
Summary:        GNU's Ubiquitous Intelligent Language for Extension
Group:          Development/Languages/Scheme

%description -n libguile-srfi-srfi-60-v-2-2
This is Guile, a portable, embeddable Scheme implementation written in
C. Guile provides a machine independent execution platform that can be
linked in as a library when building extensible programs. This package
contains the shared libraries.

%package -n libguilereadline-v-17-17
Summary:        GNU's Ubiquitous Intelligent Language for Extension
Group:          Development/Languages/Scheme

%description -n libguilereadline-v-17-17
This is Guile, a portable, embeddable Scheme implementation written in
C. Guile provides a machine independent execution platform that can be
linked in as a library when building extensible programs. This package
contains the shared libraries.


%package -n libguile1-devel
Summary:        GNU's Ubiquitous Intelligent Language for Extension
Group:          Development/Languages/Scheme
Requires:       gmp-devel
Requires:       guile1
Requires:       libguile-srfi-srfi-1-v-3-3 = %{version}-%{release}
Requires:       libguile-srfi-srfi-13-14-v-3-3 = %{version}-%{release}
Requires:       libguile-srfi-srfi-4-v-3-3 = %{version}-%{release}
Requires:       libguile-srfi-srfi-60-v-2-2 = %{version}-%{release}
Requires:       libguile17 = %{version}-%{release}
Requires:       libguilereadline-v-17-17 = %{version}-%{release}
Requires:       libguilereadline-v-17-17 = %{version}-%{release}
Requires:       libltdl-devel
Requires:       ncurses-devel
Requires:       readline-devel

%description -n libguile1-devel
This is Guile, a portable, embeddable Scheme implementation written in
C. Guile provides a machine independent execution platform that can be
linked in as a library when building extensible programs. This package
contains the files necessary to link against the guile libraries.

%prep
%setup -q -n guile-%{version}
%patch1
%patch2
%patch3
%patch5
%patch6 -p1
# guile-1.8.1: The code is not so good for -Werror (unused results of write()).
sed -i s/-Werror// configure.in configure

%build
sed -i "s:GUILE_:GUILE1_:" guile-config/guile.m4
sed -i "s:guile:guile1:" guile-config/guile.m4
autoreconf -fi
# FIXME: Following files are apparently compiled without RPM_OPT_FLAGS:
# gen-scmconfig.c,c-tokenize.c
%configure --disable-static --with-pic\
	--with-threads --program-transform-name="s:guile:%{binpref}:"
make %{?jobs:-j%jobs}

%check
make check

%install
make install DESTDIR=%{buildroot}
mkdir -p %{buildroot}%{_datadir}/guile/site
rm -r %{buildroot}%{_infodir}
# conflict with guile2
mv %{buildroot}%{_datadir}/aclocal/guile{,1}.m4
# use /usr/bin/guile1 instead of /usr/bin/guile
sed -i "s:${GUILE-guile}:${GUILE-guile1}:" %{buildroot}%{_datadir}/guile/1.8/scripts/*
sed -i "s:/usr/bin/guile:/usr/bin/guile1:" %{buildroot}%{_bindir}/guile1-config

%post -n libguile-srfi-srfi-1-v-3-3
/sbin/ldconfig

%postun -n libguile-srfi-srfi-1-v-3-3
/sbin/ldconfig

%files -n libguile-srfi-srfi-1-v-3-3
%defattr(-,root,root)
%{_libdir}/libguile-srfi-srfi-1-v-3.so.3*

%post -n libguile-srfi-srfi-4-v-3-3
/sbin/ldconfig

%postun -n libguile-srfi-srfi-4-v-3-3
/sbin/ldconfig

%files -n libguile-srfi-srfi-4-v-3-3
%defattr(-,root,root)
%{_libdir}/libguile-srfi-srfi-4-v-3.so.3*

%post -n libguile-srfi-srfi-13-14-v-3-3
/sbin/ldconfig

%postun -n libguile-srfi-srfi-13-14-v-3-3
/sbin/ldconfig

%files -n libguile-srfi-srfi-13-14-v-3-3
%defattr(-,root,root)
%{_libdir}/libguile-srfi-srfi-13-14-v-3.so.3*

%post -n libguile-srfi-srfi-60-v-2-2
/sbin/ldconfig

%postun -n libguile-srfi-srfi-60-v-2-2
/sbin/ldconfig

%files -n libguile-srfi-srfi-60-v-2-2
%defattr(-,root,root)
%{_libdir}/libguile-srfi-srfi-60-v-2.so.2*

%post -n libguile17
/sbin/ldconfig

%postun -n libguile17
/sbin/ldconfig

%files -n libguile17
%defattr(-,root,root)
%{_libdir}/libguile.so.17*

%post -n libguilereadline-v-17-17
/sbin/ldconfig

%postun -n libguilereadline-v-17-17
/sbin/ldconfig

%files -n libguilereadline-v-17-17
%defattr(-,root,root)
%{_libdir}/libguilereadline-v-17.so.17*

%pre
# Remove obsolete files (< SuSE Linux 10.2)
rm -f var/adm/SuSEconfig/md5/usr/share/guile/*/slibcat
rm -f usr/share/guile/site/slibcat.SuSEconfig

%files
%defattr(-,root,root)
%doc ABOUT-NLS AUTHORS COPYING* ChangeLog* GUILE-VERSION HACKING
%doc LICENSE NEWS README THANKS
%{_bindir}/*
%dir %{_datadir}/guile
%{_datadir}/guile/1.8
%dir %{_datadir}/guile/site
%{_mandir}/man1/%{binpref}.1.gz
# please leave *.so files here [bnc#772490]
%{_libdir}/libguile*.so

%files -n libguile1-devel
%defattr(-,root,root)
%{_includedir}/*
%{_libdir}/libguile*.la
%{_libdir}/pkgconfig/*
%{_datadir}/aclocal/guile1.m4

%changelog
